﻿/**
 * Authors: http://d.hatena.ne.jp/ultraist/
 */
module pes.random;

// ランダム

private import std.random;

// シャッフル
// 混ぜかたが適当なのでどうにかしたい
template shuffle(T: Object) {
	void shuffle(T[] array, uint count = 0)
	{
		uint max = array.length;
		
		if (max == 0) {
			return;
		}
		
		if (count == 0) {
			count =  array.length / 7 + 1;
			count += rand() % max / count;
		}
		
		for (uint i = 0; i < count; ++i) {
			uint k = rand() % max;
			uint n = rand() % max;
			
			if (k == n) {
				continue;
			}
			
			T tmp = array[k];
			array[k] = array[n];
			array[n] = tmp;
		}
	}
}


ubyte[] generateRandomBytes(uint size)
in {
	assert(size != 0);
}
body {
	ubyte[] bytes 	= new ubyte[size];
	uint	max		= ubyte.max + 1;
	
	for (uint i = 0; i < size; ++i) {
		bytes[i] = rand() % max;
	}
	
	return bytes;
}


bool probability(uint level)
{
	return (rand() % level == 0) ? true:false;
}


